/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware Technologies),
 *    Jacques Lescot (Anyware Technologies) - initial API and implementation
 *******************************************************************************/
package org.topcased.modeler.sam;

/**
 * Identifies new Action constants Creation : 25 mars 2005
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public interface SAMActionConstants
{
    
    /**
     * Misc. properties
     */
    
    /** @deprecated Remove this dialog. Use the corresponding section in the Properties View */
    String EDIT_REQUIREMENT = "editRequirement";
    
    String ADD_NEW_PORT = "AddNewPort";
    
    String INVERSE_PORTS = "inversePorts";
    
    String ROTATE = "rotate";
    
}
