package org.topcased.modeler.sysml.editor.properties.filters;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.topcased.sysml.SysMLPackage;

public class ValueTypeDimensionFilter extends AbstractModelObjectFilter
{

    protected boolean isValidModelObject(EObject obj)
    {
        EClass eClass = obj.eClass();
        return SysMLPackage.eINSTANCE.getValueType().equals(eClass) || SysMLPackage.eINSTANCE.getUnit().equals(eClass);
    }

}
