package org.topcased.modeler.sysml.editor.properties.sections;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.topcased.sysml.SysMLPackage;
import org.topcased.tabbedproperties.sections.AbstractStringPropertySection;

public class FieldNamePropertySection extends AbstractStringPropertySection
{

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractStringPropertySection#getLabelText()
     */
    protected String getLabelText()
    {
        return "Name:";
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractStringPropertySection#getLabelText()
     */
    protected EStructuralFeature getFeature()
    {
        return SysMLPackage.eINSTANCE.getField_Name();
    }

}
