package org.topcased.modeler.sysml.editor.properties.sections;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.topcased.sysml.SysMLPackage;
import org.topcased.tabbedproperties.sections.AbstractStringPropertySection;

public class FieldValuePropertySection extends AbstractStringPropertySection
{

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTextPropertySection#getLabelText()
     */
    protected String getLabelText()
    {
        return "Value:";
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTextPropertySection#getFeature()
     */
    protected EStructuralFeature getFeature()
    {
        return SysMLPackage.eINSTANCE.getField_Value();
    }

}
