package org.topcased.modeler.sysml.internalblockdiagram.figures;

import org.topcased.draw2d.figures.ComposedLabel;
import org.topcased.draw2d.figures.ILabel;
import org.topcased.draw2d.figures.Label;
import org.topcased.draw2d.figures.LabelledPortFigure;

/**
 * The figure that display a ComposedLabel associated with a ModelerPortFigure
 */
public class PortLabelledFigure extends LabelledPortFigure
{

    public PortLabelledFigure(PortFigure portFig)
    {

        super(portFig);
    }

    protected ILabel createPortLabel()
    {
        return new ComposedLabel(new Label(), new Label(), new Label(), true);
    }
}
