package org.topcased.modeler.sysml.parametricdiagram.commands;

import org.eclipse.gef.commands.Command;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Shell;

public class DisplayErrorMessageCommand extends Command
{

    String mMessage;

    Shell mShell;

    public DisplayErrorMessageCommand(String message, Shell shell)
    {
        super();
        mMessage = message;
        mShell = shell;
    }

    public boolean canUndo()
    {
        return false;
    }

    public void execute()
    {
        MessageDialog.openError(mShell, "Error", mMessage);
    }

}
