/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware
 * Technologies), Jacques Lescot (Anyware Technologies), Thomas Friol (Anyware
 * Technologies), Nicolas Laleve (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.modeler.sysml.requirementdiagram.figures;

import org.eclipse.draw2d.MarginBorder;
import org.topcased.modeler.figures.EListFigure;

/**
 * This figure hasn't the same border than a EListFigure
 */
public class FieldListFigure extends EListFigure
{
    /**
     * @see org.topcased.modeler.figures.EListFigure#drawBorder()
     */
    protected void drawBorder()
    {
        setBorder(new MarginBorder(0, 2, 2, 2));
    }
}
