// ------------------------------------------------
// $Id: MessageSignatureFilter.java,v 1.1 2007-05-24 14:43:18 jako Exp $
// (c) Anyware Technologies 2007 www.anyware-tech.com
// ------------------------------------------------
package org.topcased.modeler.uml.sequencediagram.properties.filters;

import org.eclipse.jface.viewers.IFilter;
import org.eclipse.uml2.uml.Message;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.uml.sequencediagram.SequenceUtils;
import org.topcased.modeler.uml.sequencediagram.edit.MessageEditPart;
import org.topcased.modeler.utils.Utils;

public class MessageSignatureFilter implements IFilter
{

    public boolean select(Object toTest)
    {
        Message message = null;
        if (toTest instanceof MessageEditPart)
        {
            message = (Message) Utils.getElement((GraphElement) ((MessageEditPart) toTest).getModel());
        }
        else if (toTest instanceof Message)
        {
            message = (Message) toTest;
        }
        if (message != null && SequenceUtils.isCall(message))
        {
            return true;
        }
        return false;
    }
}
