/*******************************************************************************
 * Copyright (c) 2006 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jacques Lescot (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.modeler.uml.statemachinediagram;

/**
 * Constants that are used as properties for GraphElements
 * 
 * Creation 24 oct. 06
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public interface STMPropertyConstants
{
    /** A String used to save the Layout Orientation Property of the graphical element associated with a Region */
    String REGION_LAYOUT_ORIENTATION = "RegionLayoutOrientation";
}
