/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.uml2.factories;

import org.topcased.search.core.engine.AbstractModelExtensibleSearchParameters;
import org.topcased.search.core.factories.IModelSearchQueryParametersFactory;

public class UML2ModelSearchQueryParametersFactory implements IModelSearchQueryParametersFactory {
	final class UML2ModelSearchQueryParameters extends AbstractModelExtensibleSearchParameters {
	}
	public AbstractModelExtensibleSearchParameters createSearchQueryParameters() {
		return new UML2ModelSearchQueryParameters();
	}
}
