package org.topcased.traceability.analyzers.openOffice;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;



import org.eclipse.core.resources.IFile;

import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.FileLocator;

import org.eclipse.jface.util.OpenStrategy;

import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.ide.IDE;

import tte.exceptions.EditionException;

import ttm.Document;
import ttm.Element;

public class ODTEditor {

	public static void editElement(Document document, Element element)
			throws EditionException {
		String docFilename = document.getFilename();
		URL url = null;
		File sourceFile = new File(docFilename);
		if (!sourceFile.exists()) {
			try {
				url = FileLocator.resolve(new URL(docFilename));

				sourceFile = new File(url.getFile());
			} catch (MalformedURLException e1) {
				e1.printStackTrace();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
		
		IWorkspaceRoot root = ResourcesPlugin.getWorkspace().getRoot();
		IFile file = (IFile) root.findMember(root.getLocationURI().relativize(
				sourceFile.toURI()).getPath());
/*		boolean canOpen = false;
		
		try {
			IEditorDescriptor desc = IDE.getEditorDescriptor(file);
			if (desc.isOpenInPlace()) {
				canOpen = desc.getEditorMatchingStrategy() != null;				
			}

			if (desc.isInternal()) {
				IDE.openEditor(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage(), file, "org.eclipse.ui.systemExternalEditor", OpenStrategy.activateOnOpen());
			}

			if (desc.isOpenExternal()) {
				canOpen = true;
			}		

		} catch (PartInitException e) {
			throw new EditionException("Edition failed.\n"+e.getMessage());
		}*/
/*		String dir = OpenOfficePlugin.getDefault().getPreferenceStore().getString("OpenOfficeDirectory");
		if(dir==null || !(new File(dir).exists())) {
			throw new EditionException("Cannot find OpenOffice directory, please verify its value in 'Window>Preferences...'");
		}
*/		
		try {
		IDE.openEditor(PlatformUI.getWorkbench().getActiveWorkbenchWindow()
					.getActivePage(), file,
					"org.eclipse.ui.systemExternalEditor", OpenStrategy
							.activateOnOpen());
		} catch (PartInitException e) {
			throw new EditionException(
					"Edition failed.\nNo system editor found.");
		}
	}

	// }
}
