package org.topcased.traceability.hmi.modeler.figures;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.FontMetrics;

/**
 * NOT GENERATED
 * @author phtrivier@anyware-tech.com
 */
public class CommonCoverPointFigure extends org.topcased.draw2d.figures.PortFigure {
	
	protected void outlineShape(Graphics graphics) {
		super.outlineShape(graphics);
		if (isAnd) {
			Rectangle r = getBounds();
			FontMetrics fm = graphics.getFontMetrics();
			graphics.drawText("And", r.x + (r.width - 4 * fm.getAverageCharWidth())
					/ 2, r.y + (r.height - fm.getHeight()) / 2);
		} else {
			Rectangle r = getBounds();
			FontMetrics fm = graphics.getFontMetrics();
			graphics.drawText("Or", r.x + (r.width - 2 * fm.getAverageCharWidth())
					/ 2, r.y + (r.height - fm.getHeight()) / 2);
		}
	}
	
	boolean isAnd;

	public void setIsAnd(boolean andCover) {
		isAnd = andCover;
	}
	
	
	@Override
	public Color getBackgroundColor() {
		return ColorConstants.white;
	}
	
	@Override
	public Color getForegroundColor() {
		return ColorConstants.black;			
	}
	
}
