//------------------------------------------------
// $Id: CoverItSelfSection.java,v 1.1 2007-05-22 10:23:19 matg Exp $
// (c) Anyware Technologies 2007    www.anyware-tech.com
//------------------------------------------------
package org.topcased.traceability.hmi.properties.document;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.topcased.tabbedproperties.sections.AbstractBooleanPropertySection;

import ttm.TtmPackage;

/**
 * Reprents the boolean property CoverItSelf of a document
 * <br>
 * creation : 5 avr. 07
 *
 * @author <a href="mailto:mickael.gerard@anyware-tech.com">Mickael Gerard</a>
 */
public class CoverItSelfSection extends AbstractBooleanPropertySection
{

    @Override
    protected EStructuralFeature getFeature()
    {
        return TtmPackage.eINSTANCE.getDocument_CoversItself();
    }
    
    @Override
    protected String getLabelText()
    {
        return "Covers itself";
    }
}
