package org.topcased.traceability.hmi.util;

import org.eclipse.core.resources.IResource;
import org.eclipse.emf.common.util.URI;
import org.eclipse.ui.part.FileEditorInput;

public class ResourceLoadURIHelper {

	public static URI createURI(IResource resource) {
		return URI.createPlatformResourceURI(resource.getFullPath().toString(), true);
	}

	public static URI createFileEditorInputURI(FileEditorInput editorInput) {
		return URI.createFileURI(editorInput.getPath().toPortableString());
	}


}
