/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors: Mathieu Garcia (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.traceability.hmi.util;

/**
 * Created on 21 fvr. 07
 * 
 * @author <a href="mailto:mathieu.garcia@anyware-tech.com">Mathieu Garcia</a>
 * 
 * A simple class to encapsulate a model object
 * 
 */
public class Root
{

    private Object object;

    /**
     * Default constructor
     * 
     * @param object
     */
    public Root(Object object)
    {
        this.object = object;
    }

    /**
     * Get the encapsulated object
     * 
     * @return an Object
     */
    public Object getObject()
    {
        return object;
    }
}
