package tte.extension;

/**
 * 
 * This class represents a ConversionMethod Extension
 * <br>
 * creation : 28 mai 07
 *
 * @author <a href="mailto:mathieu.garcia@anyware-tech.com">Mathieu Garcia</a>
 */
public class EditionMethodExtension {

	private String name;
	
	private  String version;

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getVersion() {
		return version;
	}

	public void setVersion(String version) {
		this.version = version;
	}
	
	public String getIdentification()
    {
        return getName()+"_"+getVersion();
    }
	
	 /**
     * @return String use for displaying the DocumentAnalyser
     */
    public String getDisplayIdentification()
    {
        return getName()+" ("+getVersion()+")";
    }
	
}
