/**
 * <copyright>
 * </copyright>
 *
 * $Id: RuleImpl.java,v 1.2 2007-03-05 10:51:01 sgabel Exp $
 */
package org.topcased.mapping.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.topcased.mapping.MappingPackage;
import org.topcased.mapping.Model;
import org.topcased.mapping.Parameter;
import org.topcased.mapping.Rule;
import org.topcased.mapping.RuleExtension;
import org.topcased.mapping.TargetElement;
import org.topcased.mapping.Variable;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.topcased.mapping.impl.RuleImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.topcased.mapping.impl.RuleImpl#getGuard <em>Guard</em>}</li>
 *   <li>{@link org.topcased.mapping.impl.RuleImpl#getSourceClass <em>Source Class</em>}</li>
 *   <li>{@link org.topcased.mapping.impl.RuleImpl#getTargetElements <em>Target Elements</em>}</li>
 *   <li>{@link org.topcased.mapping.impl.RuleImpl#getVarName <em>Var Name</em>}</li>
 *   <li>{@link org.topcased.mapping.impl.RuleImpl#getSourceModel <em>Source Model</em>}</li>
 *   <li>{@link org.topcased.mapping.impl.RuleImpl#getLocalVariables <em>Local Variables</em>}</li>
 *   <li>{@link org.topcased.mapping.impl.RuleImpl#getExtensions <em>Extensions</em>}</li>
 *   <li>{@link org.topcased.mapping.impl.RuleImpl#isIsLazy <em>Is Lazy</em>}</li>
 *   <li>{@link org.topcased.mapping.impl.RuleImpl#getParameters <em>Parameters</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RuleImpl extends EObjectImpl implements Rule {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getGuard() <em>Guard</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGuard()
	 * @generated
	 * @ordered
	 */
	protected static final String GUARD_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getGuard() <em>Guard</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGuard()
	 * @generated
	 * @ordered
	 */
	protected String guard = GUARD_EDEFAULT;

	/**
	 * The default value of the '{@link #getSourceClass() <em>Source Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceClass()
	 * @generated
	 * @ordered
	 */
	protected static final String SOURCE_CLASS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSourceClass() <em>Source Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceClass()
	 * @generated
	 * @ordered
	 */
	protected String sourceClass = SOURCE_CLASS_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTargetElements() <em>Target Elements</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTargetElements()
	 * @generated
	 * @ordered
	 */
	protected EList<TargetElement> targetElements = null;

	/**
	 * The default value of the '{@link #getVarName() <em>Var Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVarName()
	 * @generated
	 * @ordered
	 */
	protected static final String VAR_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getVarName() <em>Var Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVarName()
	 * @generated
	 * @ordered
	 */
	protected String varName = VAR_NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getSourceModel() <em>Source Model</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceModel()
	 * @generated
	 * @ordered
	 */
	protected Model sourceModel = null;

	/**
	 * The cached value of the '{@link #getLocalVariables() <em>Local Variables</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLocalVariables()
	 * @generated
	 * @ordered
	 */
	protected EList<Variable> localVariables = null;

	/**
	 * The cached value of the '{@link #getExtensions() <em>Extensions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExtensions()
	 * @generated
	 * @ordered
	 */
	protected EList<RuleExtension> extensions = null;

	/**
	 * The default value of the '{@link #isIsLazy() <em>Is Lazy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsLazy()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_LAZY_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsLazy() <em>Is Lazy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsLazy()
	 * @generated
	 * @ordered
	 */
	protected boolean isLazy = IS_LAZY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getParameters() <em>Parameters</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParameters()
	 * @generated
	 * @ordered
	 */
	protected EList<Parameter> parameters = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MappingPackage.Literals.RULE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MappingPackage.RULE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getGuard() {
		return guard;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGuard(String newGuard) {
		String oldGuard = guard;
		guard = newGuard;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MappingPackage.RULE__GUARD, oldGuard, guard));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSourceClass() {
		return sourceClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSourceClass(String newSourceClass) {
		String oldSourceClass = sourceClass;
		sourceClass = newSourceClass;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MappingPackage.RULE__SOURCE_CLASS, oldSourceClass, sourceClass));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TargetElement> getTargetElements() {
		if (targetElements == null)
		{
			targetElements = new EObjectContainmentWithInverseEList<TargetElement>(TargetElement.class, this, MappingPackage.RULE__TARGET_ELEMENTS, MappingPackage.TARGET_ELEMENT__PARENT);
		}
		return targetElements;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getVarName() {
		return varName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVarName(String newVarName) {
		String oldVarName = varName;
		varName = newVarName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MappingPackage.RULE__VAR_NAME, oldVarName, varName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Model getSourceModel() {
		if (sourceModel != null && sourceModel.eIsProxy())
		{
			InternalEObject oldSourceModel = (InternalEObject)sourceModel;
			sourceModel = (Model)eResolveProxy(oldSourceModel);
			if (sourceModel != oldSourceModel)
			{
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MappingPackage.RULE__SOURCE_MODEL, oldSourceModel, sourceModel));
			}
		}
		return sourceModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Model basicGetSourceModel() {
		return sourceModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSourceModel(Model newSourceModel) {
		Model oldSourceModel = sourceModel;
		sourceModel = newSourceModel;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MappingPackage.RULE__SOURCE_MODEL, oldSourceModel, sourceModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Variable> getLocalVariables() {
		if (localVariables == null)
		{
			localVariables = new EObjectContainmentEList<Variable>(Variable.class, this, MappingPackage.RULE__LOCAL_VARIABLES);
		}
		return localVariables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<RuleExtension> getExtensions() {
		if (extensions == null)
		{
			extensions = new EObjectContainmentEList<RuleExtension>(RuleExtension.class, this, MappingPackage.RULE__EXTENSIONS);
		}
		return extensions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsLazy() {
		return isLazy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsLazy(boolean newIsLazy) {
		boolean oldIsLazy = isLazy;
		isLazy = newIsLazy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MappingPackage.RULE__IS_LAZY, oldIsLazy, isLazy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Parameter> getParameters() {
		if (parameters == null)
		{
			parameters = new EObjectContainmentEList<Parameter>(Parameter.class, this, MappingPackage.RULE__PARAMETERS);
		}
		return parameters;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case MappingPackage.RULE__TARGET_ELEMENTS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getTargetElements()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case MappingPackage.RULE__TARGET_ELEMENTS:
				return ((InternalEList<?>)getTargetElements()).basicRemove(otherEnd, msgs);
			case MappingPackage.RULE__LOCAL_VARIABLES:
				return ((InternalEList<?>)getLocalVariables()).basicRemove(otherEnd, msgs);
			case MappingPackage.RULE__EXTENSIONS:
				return ((InternalEList<?>)getExtensions()).basicRemove(otherEnd, msgs);
			case MappingPackage.RULE__PARAMETERS:
				return ((InternalEList<?>)getParameters()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType)
	{
		switch (featureID)
		{
			case MappingPackage.RULE__NAME:
				return getName();
			case MappingPackage.RULE__GUARD:
				return getGuard();
			case MappingPackage.RULE__SOURCE_CLASS:
				return getSourceClass();
			case MappingPackage.RULE__TARGET_ELEMENTS:
				return getTargetElements();
			case MappingPackage.RULE__VAR_NAME:
				return getVarName();
			case MappingPackage.RULE__SOURCE_MODEL:
				if (resolve) return getSourceModel();
				return basicGetSourceModel();
			case MappingPackage.RULE__LOCAL_VARIABLES:
				return getLocalVariables();
			case MappingPackage.RULE__EXTENSIONS:
				return getExtensions();
			case MappingPackage.RULE__IS_LAZY:
				return isIsLazy() ? Boolean.TRUE : Boolean.FALSE;
			case MappingPackage.RULE__PARAMETERS:
				return getParameters();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue)
	{
		switch (featureID)
		{
			case MappingPackage.RULE__NAME:
				setName((String)newValue);
				return;
			case MappingPackage.RULE__GUARD:
				setGuard((String)newValue);
				return;
			case MappingPackage.RULE__SOURCE_CLASS:
				setSourceClass((String)newValue);
				return;
			case MappingPackage.RULE__TARGET_ELEMENTS:
				getTargetElements().clear();
				getTargetElements().addAll((Collection<? extends TargetElement>)newValue);
				return;
			case MappingPackage.RULE__VAR_NAME:
				setVarName((String)newValue);
				return;
			case MappingPackage.RULE__SOURCE_MODEL:
				setSourceModel((Model)newValue);
				return;
			case MappingPackage.RULE__LOCAL_VARIABLES:
				getLocalVariables().clear();
				getLocalVariables().addAll((Collection<? extends Variable>)newValue);
				return;
			case MappingPackage.RULE__EXTENSIONS:
				getExtensions().clear();
				getExtensions().addAll((Collection<? extends RuleExtension>)newValue);
				return;
			case MappingPackage.RULE__IS_LAZY:
				setIsLazy(((Boolean)newValue).booleanValue());
				return;
			case MappingPackage.RULE__PARAMETERS:
				getParameters().clear();
				getParameters().addAll((Collection<? extends Parameter>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID)
	{
		switch (featureID)
		{
			case MappingPackage.RULE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case MappingPackage.RULE__GUARD:
				setGuard(GUARD_EDEFAULT);
				return;
			case MappingPackage.RULE__SOURCE_CLASS:
				setSourceClass(SOURCE_CLASS_EDEFAULT);
				return;
			case MappingPackage.RULE__TARGET_ELEMENTS:
				getTargetElements().clear();
				return;
			case MappingPackage.RULE__VAR_NAME:
				setVarName(VAR_NAME_EDEFAULT);
				return;
			case MappingPackage.RULE__SOURCE_MODEL:
				setSourceModel((Model)null);
				return;
			case MappingPackage.RULE__LOCAL_VARIABLES:
				getLocalVariables().clear();
				return;
			case MappingPackage.RULE__EXTENSIONS:
				getExtensions().clear();
				return;
			case MappingPackage.RULE__IS_LAZY:
				setIsLazy(IS_LAZY_EDEFAULT);
				return;
			case MappingPackage.RULE__PARAMETERS:
				getParameters().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID)
	{
		switch (featureID)
		{
			case MappingPackage.RULE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case MappingPackage.RULE__GUARD:
				return GUARD_EDEFAULT == null ? guard != null : !GUARD_EDEFAULT.equals(guard);
			case MappingPackage.RULE__SOURCE_CLASS:
				return SOURCE_CLASS_EDEFAULT == null ? sourceClass != null : !SOURCE_CLASS_EDEFAULT.equals(sourceClass);
			case MappingPackage.RULE__TARGET_ELEMENTS:
				return targetElements != null && !targetElements.isEmpty();
			case MappingPackage.RULE__VAR_NAME:
				return VAR_NAME_EDEFAULT == null ? varName != null : !VAR_NAME_EDEFAULT.equals(varName);
			case MappingPackage.RULE__SOURCE_MODEL:
				return sourceModel != null;
			case MappingPackage.RULE__LOCAL_VARIABLES:
				return localVariables != null && !localVariables.isEmpty();
			case MappingPackage.RULE__EXTENSIONS:
				return extensions != null && !extensions.isEmpty();
			case MappingPackage.RULE__IS_LAZY:
				return isLazy != IS_LAZY_EDEFAULT;
			case MappingPackage.RULE__PARAMETERS:
				return parameters != null && !parameters.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", guard: ");
		result.append(guard);
		result.append(", sourceClass: ");
		result.append(sourceClass);
		result.append(", varName: ");
		result.append(varName);
		result.append(", isLazy: ");
		result.append(isLazy);
		result.append(')');
		return result.toString();
	}

} //RuleImpl
