package org.topcased.modeler.sysml.blockdefinitiondiagram.figures;

import org.eclipse.draw2d.CompoundBorder;
import org.eclipse.draw2d.MarginBorder;
import org.topcased.modeler.figures.EListFigure;

/**
 * EListFigure which top and right margin to enable to place ports
 */

public class EListBlockFigure extends EListFigure
{
    private static final int RIGHTLEFT_MARGIN = 20;

    private static final int TOPBOTTOM_MARGIN = 2;

    /**
     * @see org.topcased.modeler.figures.EListFigure#drawBorder()
     */
    protected void drawBorder()
    {
        setBorder(new CompoundBorder(new EListFigureBorder(), new MarginBorder(TOPBOTTOM_MARGIN, RIGHTLEFT_MARGIN,
                TOPBOTTOM_MARGIN, RIGHTLEFT_MARGIN)));
    }
}
