/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.modeler.uml.compositestructuresdiagram.figures;

import org.topcased.draw2d.figures.ComposedLabel;
import org.topcased.draw2d.figures.EditableLabel;
import org.topcased.draw2d.figures.ILabel;
import org.topcased.draw2d.figures.Label;
import org.topcased.modeler.uml.compositestructuresdiagram.figures.internal.InternalPortFigure;

public class PortFigure extends org.topcased.draw2d.figures.LabelledPortFigure
{

	/**
	 * Constructor
	 */
	public PortFigure() {
		super(new InternalPortFigure());
	}
	
	/**
	 * @see org.topcased.draw2d.figures.LabelledPortFigure#createPortLabel()
	 */
	protected ILabel createPortLabel()
	{
	    return new ComposedLabel(new EditableLabel(), new Label(), null, true);
	}
	
	
}
