/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware
 * Technologies), Jacques Lescot (Anyware Technologies), Thomas Friol (Anyware
 * Technologies), Nicolas Lalevée (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.modeler.uml.sequencediagram.dialogs;

import org.eclipse.gef.commands.Command;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.widgets.Shell;

/**
 * Dialog that produce a command
 * 
 * @author <a href="mailto:nicolas.lalevee@anyware-tech.com">Nicolas Lalevée</a>
 * @deprecated Should not be used anymore as the MessageEditDialog is deprecated (and this was the only one class that
 *             were implementing this interface)
 */
public abstract class CommandDialog extends Dialog
{

    /**
     * Constructor
     * 
     * @param parentShell the owning shell
     */
    protected CommandDialog(Shell parentShell)
    {
        super(parentShell);
    }

    /**
     * Return the command
     * 
     * @return the command
     */
    public abstract Command getCommand();
}
