package org.topcased.search.ui.sorters;


import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;

public class AbstractMetaModelParticipantsViewerSorter extends ViewerSorter {
	@Override
	public int compare(Viewer viewer, Object e1, Object e2) {
		EClassifier eClass1 = (EClassifier) e1; 
		EClassifier eClass2 = (EClassifier) e2; 
		
		String eClass1Name = "";
		if (e1 instanceof EClass) {
			eClass1Name += "ETypeKind_1_";
		} else if (e1 instanceof EDataType) {
			eClass1Name += "ETypeKind_2_";
		}
		eClass1Name += eClass1.getName()==null?"":eClass1.getName();
		
		
		String eClass2Name = "";
		if (e2 instanceof EClass) {
			eClass2Name += "ETypeKind_1_";
		} else if (e2 instanceof EDataType) {
			eClass2Name += "ETypeKind_2_";
		}
		eClass2Name += eClass2.getName()==null?"":eClass2.getName();
		
		return eClass1Name.compareTo(eClass2Name);
	}
}
