package org.topcased.service.comparison;

import org.eclipse.core.runtime.Path;

/**
 * This interface defines constantes use during the comparison plug-in.
 * 
 * @author <a href="mailto:sebastien.gabel@c-s.fr">Sebastien GABEL</a>
 *
 */
public interface ComparisonImageConstantes
{
	public static final String ICON_FOLDER = "icons";
	
	public static final String ADD_FROM_LEFT = ICON_FOLDER + Path.SEPARATOR + "addobjectfromleft.gif";
	
	public static final String DEL_FROM_LEFT = ICON_FOLDER + Path.SEPARATOR + "deleteobjectfromleft.gif";
	
	public static final String ADD_FROM_RIGHT = ICON_FOLDER + Path.SEPARATOR + "addobjectfromright.gif";
	
	public static final String DEL_FROM_RIGHT = ICON_FOLDER + Path.SEPARATOR + "deleteobjectfromright.gif";
	
	public static final String MODIFIED = ICON_FOLDER + Path.SEPARATOR + "modifiedobject.gif";
	
	public static final String COMPARISON = ICON_FOLDER + Path.SEPARATOR + "comparison.gif";
	
	public static final String OLD_OBJECT = ICON_FOLDER + Path.SEPARATOR + "oldobject.gif";
	
	public static final String NEW_OBJECT = ICON_FOLDER + Path.SEPARATOR + "newobject.gif";
	
	public static final String MERGE_OBJECT = ICON_FOLDER + Path.SEPARATOR + "mergeobject.gif";
	
	public static final String DELETE_OBJECT = ICON_FOLDER + Path.SEPARATOR + "deleteobject.gif";
	
	public static final String SAVE_OBJECT = ICON_FOLDER + Path.SEPARATOR + "saveobject.gif";
}
