/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.service.plugincustomization.actions;

import java.util.HashMap;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.topcased.service.plugincustomization.services.EclipsePreferencesCreation;

public class PreferenceCreationAction implements IObjectActionDelegate
{

	public void setActivePart(IAction action, IWorkbenchPart targetPart)
	{
		// Nothing to do
	}

	public void run(IAction action)
	{
		EclipsePreferencesCreation service = new EclipsePreferencesCreation();
		service.serviceRun(new HashMap<String, Object>());
	}

	public void selectionChanged(IAction action, ISelection selection)
	{
		// Nothing to do
	}
}