/**
 * <copyright> </copyright>
 * 
 * $Id: PackageSYSML.java,v 1.3 2007-06-22 08:51:20 tlandre Exp $
 */
package org.topcased.sysml;

import org.eclipse.emf.common.util.EList;
import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.DataType;
import org.eclipse.uml2.uml.GeneralizationSet;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.Relationship;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em> < ? >Package SYSML</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedBlockDefinition <em>Owned Block Definition</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedRequirementDefinition <em>Owned Requirement Definition</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedSatisfy <em>Owned Satisfy</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedTestCase <em>Owned Test Case</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedTraceDependency <em>Owned Trace Dependency</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedRequirement <em>Owned Requirement</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedItemFlow <em>Owned Item Flow</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedInterfaces <em>Owned Interfaces</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedGenSet <em>Owned Gen Set</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedActors <em>Owned Actors</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedBlocks <em>Owned Blocks</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedDataTypes <em>Owned Data Types</em>}</li>
 *   <li>{@link org.topcased.sysml.PackageSYSML#getOwnedRelationships <em>Owned Relationships</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML()
 * @model annotation="http://www.topcased.org/uuid uuid='113941280457735'"
 * @generated
 */
public interface PackageSYSML extends org.eclipse.uml2.uml.Package
{
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    String copyright = "";

    /**
	 * Returns the value of the '<em><b>Owned Block Definition</b></em>' containment reference list.
	 * The list contents are of type {@link org.topcased.sysml.BlockDefinition}.
	 * <!-- begin-user-doc --> < ? >
     * If the meaning of the '<em>Owned Block Definition</em>' containment
     * reference list isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Block Definition</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedBlockDefinition()
	 * @model type="org.topcased.sysml.BlockDefinition" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='113941280457736'"
	 * @generated
	 */
    EList<BlockDefinition> getOwnedBlockDefinition();

    /**
	 * Returns the value of the '<em><b>Owned Requirement Definition</b></em>' containment reference list.
	 * The list contents are of type {@link org.topcased.sysml.RequirementDefinition}.
	 * <!-- begin-user-doc
     * --> < ? > If the meaning of the '<em>Owned Requirement Definition</em>'
     * containment reference list isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Requirement Definition</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedRequirementDefinition()
	 * @model type="org.topcased.sysml.RequirementDefinition" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='114130792049551'"
	 * @generated
	 */
    EList<RequirementDefinition> getOwnedRequirementDefinition();

				/**
	 * Returns the value of the '<em><b>Owned Satisfy</b></em>' containment reference list.
	 * The list contents are of type {@link org.topcased.sysml.Satisfy}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Satisfy</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Satisfy</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedSatisfy()
	 * @model type="org.topcased.sysml.Satisfy" containment="true"
	 * @generated
	 */
	EList<Satisfy> getOwnedSatisfy();

				/**
	 * Returns the value of the '<em><b>Owned Test Case</b></em>' containment reference list.
	 * The list contents are of type {@link org.topcased.sysml.TestCase}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Test Case</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Test Case</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedTestCase()
	 * @model type="org.topcased.sysml.TestCase" containment="true"
	 * @generated
	 */
	EList<TestCase> getOwnedTestCase();

				/**
	 * Returns the value of the '<em><b>Owned Trace Dependency</b></em>' containment reference list.
	 * The list contents are of type {@link org.topcased.sysml.Trace}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Trace Dependency</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Trace Dependency</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedTraceDependency()
	 * @model type="org.topcased.sysml.Trace" containment="true"
	 * @generated
	 */
	EList<Trace> getOwnedTraceDependency();

				/**
	 * Returns the value of the '<em><b>Owned Requirement</b></em>' containment reference list.
	 * The list contents are of type {@link org.topcased.sysml.Requirement}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Requirement</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Requirement</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedRequirement()
	 * @model type="org.topcased.sysml.Requirement" containment="true"
	 * @generated
	 */
	EList<Requirement> getOwnedRequirement();

				/**
	 * Returns the value of the '<em><b>Owned Item Flow</b></em>' containment reference list.
	 * The list contents are of type {@link org.topcased.sysml.ItemFlow}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Item Flow</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Item Flow</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedItemFlow()
	 * @model type="org.topcased.sysml.ItemFlow" containment="true"
	 * @generated
	 */
	EList<ItemFlow> getOwnedItemFlow();

				/**
	 * Returns the value of the '<em><b>Owned Interfaces</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.uml2.uml.Interface}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Interfaces</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Interfaces</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedInterfaces()
	 * @model type="org.eclipse.uml2.uml.Interface" containment="true"
	 * @generated
	 */
	EList<Interface> getOwnedInterfaces();

				/**
	 * Returns the value of the '<em><b>Owned Gen Set</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.uml2.uml.GeneralizationSet}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Gen Set</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Gen Set</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedGenSet()
	 * @model type="org.eclipse.uml2.uml.GeneralizationSet" containment="true"
	 * @generated
	 */
	EList<GeneralizationSet> getOwnedGenSet();

				/**
	 * Returns the value of the '<em><b>Owned Actors</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.uml2.uml.Actor}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Actors</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Actors</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedActors()
	 * @model type="org.eclipse.uml2.uml.Actor" containment="true"
	 * @generated
	 */
	EList<Actor> getOwnedActors();

				/**
	 * Returns the value of the '<em><b>Owned Blocks</b></em>' containment reference list.
	 * The list contents are of type {@link org.topcased.sysml.Block}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Blocks</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Blocks</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedBlocks()
	 * @model type="org.topcased.sysml.Block" containment="true"
	 * @generated
	 */
	EList<Block> getOwnedBlocks();

				/**
	 * Returns the value of the '<em><b>Owned Data Types</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.uml2.uml.DataType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Data Types</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Data Types</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedDataTypes()
	 * @model type="org.eclipse.uml2.uml.DataType" containment="true"
	 * @generated
	 */
	EList<DataType> getOwnedDataTypes();

				/**
	 * Returns the value of the '<em><b>Owned Relationships</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.uml2.uml.Relationship}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Relationships</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Relationships</em>' containment reference list.
	 * @see org.topcased.sysml.SysMLPackage#getPackageSYSML_OwnedRelationships()
	 * @model type="org.eclipse.uml2.uml.Relationship" containment="true"
	 * @generated
	 */
	EList<Relationship> getOwnedRelationships();

} // PackageSYSML
