/**
 * <copyright> </copyright>
 * 
 * $Id: RequirementImpl.java,v 1.2 2007-05-22 08:46:03 tlandre Exp $
 */
package org.topcased.sysml.impl;

import java.util.Collection;
import java.util.Iterator;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.UniqueEList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EcoreEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.uml2.uml.internal.impl.ClassImpl;
import org.topcased.sysml.Containment;
import org.topcased.sysml.Copy;
import org.topcased.sysml.DeriveReqt;
import org.topcased.sysml.Field;
import org.topcased.sysml.Refine;
import org.topcased.sysml.Requirement;
import org.topcased.sysml.RequirementKind;
import org.topcased.sysml.RiskKind;
import org.topcased.sysml.Satisfy;
import org.topcased.sysml.SysMLPackage;
import org.topcased.sysml.TestCase;
import org.topcased.sysml.Trace;
import org.topcased.sysml.Verify;
import org.topcased.sysml.VerifyMethodKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em> < ? >Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getId <em>Id</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getSource <em>Source</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getText <em>Text</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getKind <em>Kind</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getRisk <em>Risk</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getVerifyMethod <em>Verify Method</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getExtendedField <em>Extended Field</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getDerivedFrom <em>Derived From</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getDerived <em>Derived</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getVerifiedBy <em>Verified By</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getTracedTo <em>Traced To</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getSatisfiedBy <em>Satisfied By</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getRefinedBy <em>Refined By</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getMaster <em>Master</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.RequirementImpl#getOwnedContainment <em>Owned Containment</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RequirementImpl extends ClassImpl implements Requirement
{
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
     * The default value of the '{@link #getId() <em>Id</em>}' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getId()
     * @generated
     * @ordered
     */
    protected static final String ID_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getId() <em>Id</em>}' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getId()
     * @generated
     * @ordered
     */
    protected String id = ID_EDEFAULT;

    /**
	 * The default value of the '{@link #getSource() <em>Source</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSource()
	 * @generated
	 * @ordered
	 */
    protected static final String SOURCE_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getSource() <em>Source</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSource()
	 * @generated
	 * @ordered
	 */
    protected String source = SOURCE_EDEFAULT;

    /**
	 * The default value of the '{@link #getText() <em>Text</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getText()
	 * @generated
	 * @ordered
	 */
    protected static final String TEXT_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getText() <em>Text</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getText()
	 * @generated
	 * @ordered
	 */
    protected String text = TEXT_EDEFAULT;

    /**
	 * The default value of the '{@link #getKind() <em>Kind</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getKind()
	 * @generated
	 * @ordered
	 */
    protected static final RequirementKind KIND_EDEFAULT = RequirementKind.FUNCTIONAL_LITERAL;

    /**
	 * The cached value of the '{@link #getKind() <em>Kind</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getKind()
	 * @generated
	 * @ordered
	 */
    protected RequirementKind kind = KIND_EDEFAULT;

    /**
	 * The default value of the '{@link #getRisk() <em>Risk</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRisk()
	 * @generated
	 * @ordered
	 */
    protected static final RiskKind RISK_EDEFAULT = RiskKind.HIGH_LITERAL;

    /**
	 * The cached value of the '{@link #getRisk() <em>Risk</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRisk()
	 * @generated
	 * @ordered
	 */
    protected RiskKind risk = RISK_EDEFAULT;

    /**
	 * The default value of the '{@link #getVerifyMethod() <em>Verify Method</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getVerifyMethod()
	 * @generated
	 * @ordered
	 */
    protected static final VerifyMethodKind VERIFY_METHOD_EDEFAULT = VerifyMethodKind.ANALYSIS_LITERAL;

    /**
	 * The cached value of the '{@link #getVerifyMethod() <em>Verify Method</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getVerifyMethod()
	 * @generated
	 * @ordered
	 */
    protected VerifyMethodKind verifyMethod = VERIFY_METHOD_EDEFAULT;

    /**
	 * The cached value of the '{@link #getExtendedField() <em>Extended Field</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getExtendedField()
	 * @generated
	 * @ordered
	 */
    protected EList<Field> extendedField;

    /**
	 * The cached value of the '{@link #getOwnedContainment() <em>Owned Containment</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getOwnedContainment()
	 * @generated
	 * @ordered
	 */
    protected EList<Containment> ownedContainment;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected RequirementImpl()
    {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass()
    {
		return SysMLPackage.Literals.REQUIREMENT;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getId()
    {
		return id;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setId(String newId)
    {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SysMLPackage.REQUIREMENT__ID, oldId, id));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getSource()
    {
		return source;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setSource(String newSource)
    {
		String oldSource = source;
		source = newSource;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SysMLPackage.REQUIREMENT__SOURCE, oldSource, source));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getText()
    {
		return text;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setText(String newText)
    {
		String oldText = text;
		text = newText;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SysMLPackage.REQUIREMENT__TEXT, oldText, text));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public RequirementKind getKind()
    {
		return kind;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setKind(RequirementKind newKind)
    {
		RequirementKind oldKind = kind;
		kind = newKind == null ? KIND_EDEFAULT : newKind;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SysMLPackage.REQUIREMENT__KIND, oldKind, kind));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public RiskKind getRisk()
    {
		return risk;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setRisk(RiskKind newRisk)
    {
		RiskKind oldRisk = risk;
		risk = newRisk == null ? RISK_EDEFAULT : newRisk;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SysMLPackage.REQUIREMENT__RISK, oldRisk, risk));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public VerifyMethodKind getVerifyMethod()
    {
		return verifyMethod;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setVerifyMethod(VerifyMethodKind newVerifyMethod)
    {
		VerifyMethodKind oldVerifyMethod = verifyMethod;
		verifyMethod = newVerifyMethod == null ? VERIFY_METHOD_EDEFAULT : newVerifyMethod;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SysMLPackage.REQUIREMENT__VERIFY_METHOD, oldVerifyMethod, verifyMethod));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<Field> getExtendedField()
    {
		if (extendedField == null) {
			extendedField = new EObjectContainmentEList<Field>(Field.class, this, SysMLPackage.REQUIREMENT__EXTENDED_FIELD);
		}
		return extendedField;
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public EList getDerivedFrom()
    {
        EList derivedFrom = new UniqueEList();
        Collection allDerivedLinks = ItemPropertyDescriptor.getReachableObjectsOfType(this,
                SysMLPackage.eINSTANCE.getDeriveReqt());
        for (Iterator it = allDerivedLinks.iterator(); it.hasNext();)
        {
            DeriveReqt deriveLink = (DeriveReqt) it.next();
            if (deriveLink.getClients().contains(this))
                addAllItemsOfClass(derivedFrom, deriveLink.getSuppliers(), Requirement.class);
        }
        return new EcoreEList.UnmodifiableEList(this, SysMLPackage.eINSTANCE.getRequirement_DerivedFrom(),
                derivedFrom.size(), derivedFrom.toArray());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public EList getDerived()
    {
        EList derived = new UniqueEList();
        Collection allDerivedLinks = ItemPropertyDescriptor.getReachableObjectsOfType(this,
                SysMLPackage.eINSTANCE.getDeriveReqt());
        for (Iterator it = allDerivedLinks.iterator(); it.hasNext();)
        {
            DeriveReqt deriveLink = (DeriveReqt) it.next();
            if (deriveLink.getSuppliers().contains(this))
                addAllItemsOfClass(derived, deriveLink.getClients(), Requirement.class);
        }
        return new EcoreEList.UnmodifiableEList(this, SysMLPackage.eINSTANCE.getRequirement_Derived(), derived.size(),
                derived.toArray());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public EList getVerifiedBy()
    {
        EList verifiedBy = new UniqueEList();
        Collection allVerifyLinks = ItemPropertyDescriptor.getReachableObjectsOfType(this,
                SysMLPackage.eINSTANCE.getVerify());
        for (Iterator it = allVerifyLinks.iterator(); it.hasNext();)
        {
            Verify verifyLink = (Verify) it.next();
            if (verifyLink.getSuppliers().contains(this))
                addAllItemsOfClass(verifiedBy, verifyLink.getClients(), TestCase.class);
        }
        return new EcoreEList.UnmodifiableEList(this, SysMLPackage.eINSTANCE.getRequirement_VerifiedBy(),
                verifiedBy.size(), verifiedBy.toArray());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public EList getTracedTo()
    {
        EList tracedTo = new UniqueEList();
        Collection allTraceLinks = ItemPropertyDescriptor.getReachableObjectsOfType(this,
                SysMLPackage.eINSTANCE.getTrace());
        for (Iterator it = allTraceLinks.iterator(); it.hasNext();)
        {
            Trace traceLink = (Trace) it.next();
            if (traceLink.eClass() == SysMLPackage.eINSTANCE.getTrace() && traceLink.getSuppliers().contains(this))
                tracedTo.addAll(traceLink.getClients());
        }
        return new EcoreEList.UnmodifiableEList(this, SysMLPackage.eINSTANCE.getRequirement_TracedTo(),
                tracedTo.size(), tracedTo.toArray());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public EList getSatisfiedBy()
    {
        EList satisfyBy = new UniqueEList();
        Collection allSatisfyLinks = ItemPropertyDescriptor.getReachableObjectsOfType(this,
                SysMLPackage.eINSTANCE.getSatisfy());
        for (Iterator it = allSatisfyLinks.iterator(); it.hasNext();)
        {
            Satisfy satisfyLink = (Satisfy) it.next();
            if (satisfyLink.getSuppliers().contains(this))
                satisfyBy.addAll(satisfyLink.getClients());
        }
        return new EcoreEList.UnmodifiableEList(this, SysMLPackage.eINSTANCE.getRequirement_SatisfiedBy(),
                satisfyBy.size(), satisfyBy.toArray());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public EList getRefinedBy()
    {
        EList refinedBy = new UniqueEList();
        Collection allRefineLinks = ItemPropertyDescriptor.getReachableObjectsOfType(this,
                SysMLPackage.eINSTANCE.getRefine());
        for (Iterator it = allRefineLinks.iterator(); it.hasNext();)
        {
            Refine refineLink = (Refine) it.next();
            if (refineLink.getSuppliers().contains(this))
                refinedBy.addAll(refineLink.getClients());
        }
        return new EcoreEList.UnmodifiableEList(this, SysMLPackage.eINSTANCE.getRequirement_RefinedBy(),
                refinedBy.size(), refinedBy.toArray());
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Requirement getMaster()
    {
		Requirement master = basicGetMaster();
		return master != null && master.eIsProxy() ? (Requirement)eResolveProxy((InternalEObject)master) : master;
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public Requirement basicGetMaster()
    {
        Collection allCopyLinks = ItemPropertyDescriptor.getReachableObjectsOfType(this,
                SysMLPackage.eINSTANCE.getCopy());
        for (Iterator it = allCopyLinks.iterator(); it.hasNext();)
        {
            Copy copyLink = (Copy) it.next();
            if (copyLink.getClients().contains(this))
            {
                for (Iterator itSupp = copyLink.getSuppliers().iterator(); itSupp.hasNext();)
                {
                    Object supplier = itSupp.next();
                    if (supplier instanceof Requirement)
                        return (Requirement) supplier;
                }
            }
        }
        return null;
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<Containment> getOwnedContainment()
    {
		if (ownedContainment == null) {
			ownedContainment = new EObjectContainmentEList<Containment>(Containment.class, this, SysMLPackage.REQUIREMENT__OWNED_CONTAINMENT);
		}
		return ownedContainment;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case SysMLPackage.REQUIREMENT__EXTENDED_FIELD:
				return ((InternalEList<?>)getExtendedField()).basicRemove(otherEnd, msgs);
			case SysMLPackage.REQUIREMENT__OWNED_CONTAINMENT:
				return ((InternalEList<?>)getOwnedContainment()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType)
    {
		switch (featureID) {
			case SysMLPackage.REQUIREMENT__ID:
				return getId();
			case SysMLPackage.REQUIREMENT__SOURCE:
				return getSource();
			case SysMLPackage.REQUIREMENT__TEXT:
				return getText();
			case SysMLPackage.REQUIREMENT__KIND:
				return getKind();
			case SysMLPackage.REQUIREMENT__RISK:
				return getRisk();
			case SysMLPackage.REQUIREMENT__VERIFY_METHOD:
				return getVerifyMethod();
			case SysMLPackage.REQUIREMENT__EXTENDED_FIELD:
				return getExtendedField();
			case SysMLPackage.REQUIREMENT__DERIVED_FROM:
				return getDerivedFrom();
			case SysMLPackage.REQUIREMENT__DERIVED:
				return getDerived();
			case SysMLPackage.REQUIREMENT__VERIFIED_BY:
				return getVerifiedBy();
			case SysMLPackage.REQUIREMENT__TRACED_TO:
				return getTracedTo();
			case SysMLPackage.REQUIREMENT__SATISFIED_BY:
				return getSatisfiedBy();
			case SysMLPackage.REQUIREMENT__REFINED_BY:
				return getRefinedBy();
			case SysMLPackage.REQUIREMENT__MASTER:
				if (resolve) return getMaster();
				return basicGetMaster();
			case SysMLPackage.REQUIREMENT__OWNED_CONTAINMENT:
				return getOwnedContainment();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue)
    {
		switch (featureID) {
			case SysMLPackage.REQUIREMENT__ID:
				setId((String)newValue);
				return;
			case SysMLPackage.REQUIREMENT__SOURCE:
				setSource((String)newValue);
				return;
			case SysMLPackage.REQUIREMENT__TEXT:
				setText((String)newValue);
				return;
			case SysMLPackage.REQUIREMENT__KIND:
				setKind((RequirementKind)newValue);
				return;
			case SysMLPackage.REQUIREMENT__RISK:
				setRisk((RiskKind)newValue);
				return;
			case SysMLPackage.REQUIREMENT__VERIFY_METHOD:
				setVerifyMethod((VerifyMethodKind)newValue);
				return;
			case SysMLPackage.REQUIREMENT__EXTENDED_FIELD:
				getExtendedField().clear();
				getExtendedField().addAll((Collection<? extends Field>)newValue);
				return;
			case SysMLPackage.REQUIREMENT__OWNED_CONTAINMENT:
				getOwnedContainment().clear();
				getOwnedContainment().addAll((Collection<? extends Containment>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID)
    {
		switch (featureID) {
			case SysMLPackage.REQUIREMENT__ID:
				setId(ID_EDEFAULT);
				return;
			case SysMLPackage.REQUIREMENT__SOURCE:
				setSource(SOURCE_EDEFAULT);
				return;
			case SysMLPackage.REQUIREMENT__TEXT:
				setText(TEXT_EDEFAULT);
				return;
			case SysMLPackage.REQUIREMENT__KIND:
				setKind(KIND_EDEFAULT);
				return;
			case SysMLPackage.REQUIREMENT__RISK:
				setRisk(RISK_EDEFAULT);
				return;
			case SysMLPackage.REQUIREMENT__VERIFY_METHOD:
				setVerifyMethod(VERIFY_METHOD_EDEFAULT);
				return;
			case SysMLPackage.REQUIREMENT__EXTENDED_FIELD:
				getExtendedField().clear();
				return;
			case SysMLPackage.REQUIREMENT__OWNED_CONTAINMENT:
				getOwnedContainment().clear();
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID)
    {
		switch (featureID) {
			case SysMLPackage.REQUIREMENT__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case SysMLPackage.REQUIREMENT__SOURCE:
				return SOURCE_EDEFAULT == null ? source != null : !SOURCE_EDEFAULT.equals(source);
			case SysMLPackage.REQUIREMENT__TEXT:
				return TEXT_EDEFAULT == null ? text != null : !TEXT_EDEFAULT.equals(text);
			case SysMLPackage.REQUIREMENT__KIND:
				return kind != KIND_EDEFAULT;
			case SysMLPackage.REQUIREMENT__RISK:
				return risk != RISK_EDEFAULT;
			case SysMLPackage.REQUIREMENT__VERIFY_METHOD:
				return verifyMethod != VERIFY_METHOD_EDEFAULT;
			case SysMLPackage.REQUIREMENT__EXTENDED_FIELD:
				return extendedField != null && !extendedField.isEmpty();
			case SysMLPackage.REQUIREMENT__DERIVED_FROM:
				return !getDerivedFrom().isEmpty();
			case SysMLPackage.REQUIREMENT__DERIVED:
				return !getDerived().isEmpty();
			case SysMLPackage.REQUIREMENT__VERIFIED_BY:
				return !getVerifiedBy().isEmpty();
			case SysMLPackage.REQUIREMENT__TRACED_TO:
				return !getTracedTo().isEmpty();
			case SysMLPackage.REQUIREMENT__SATISFIED_BY:
				return !getSatisfiedBy().isEmpty();
			case SysMLPackage.REQUIREMENT__REFINED_BY:
				return !getRefinedBy().isEmpty();
			case SysMLPackage.REQUIREMENT__MASTER:
				return basicGetMaster() != null;
			case SysMLPackage.REQUIREMENT__OWNED_CONTAINMENT:
				return ownedContainment != null && !ownedContainment.isEmpty();
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString()
    {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (id: ");
		result.append(id);
		result.append(", source: ");
		result.append(source);
		result.append(", text: ");
		result.append(text);
		result.append(", kind: ");
		result.append(kind);
		result.append(", risk: ");
		result.append(risk);
		result.append(", verifyMethod: ");
		result.append(verifyMethod);
		result.append(')');
		return result.toString();
	}

    private void addAllItemsOfClass(Collection col, Collection itemsToAdd, Class itemsClass)
    {
        for (Iterator it = itemsToAdd.iterator(); it.hasNext();)
        {
            Object item = it.next();
            if (itemsClass.isInstance(item))
            {
                col.add(item);
            }
        }
    }

} // RequirementImpl
