/**
 * <copyright> </copyright>
 * 
 * $Id: SysMLPackageImpl.java,v 1.3 2007-06-22 08:51:20 tlandre Exp $
 */
package org.topcased.sysml.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.sysml.Block;
import org.topcased.sysml.BlockDefinition;
import org.topcased.sysml.BlockProperty;
import org.topcased.sysml.ConstraintBlock;
import org.topcased.sysml.ConstraintProperty;
import org.topcased.sysml.Containment;
import org.topcased.sysml.Copy;
import org.topcased.sysml.DeriveReqt;
import org.topcased.sysml.Dimension;
import org.topcased.sysml.DistributedProperty;
import org.topcased.sysml.Field;
import org.topcased.sysml.FlowDirectionKind;
import org.topcased.sysml.FlowPort;
import org.topcased.sysml.FlowProperty;
import org.topcased.sysml.FlowSpecification;
import org.topcased.sysml.ItemFlow;
import org.topcased.sysml.ModelSYSML;
import org.topcased.sysml.PackageSYSML;
import org.topcased.sysml.Problem;
import org.topcased.sysml.Rationale;
import org.topcased.sysml.Refine;
import org.topcased.sysml.Requirement;
import org.topcased.sysml.RequirementDefinition;
import org.topcased.sysml.RequirementKind;
import org.topcased.sysml.RequirementRelated;
import org.topcased.sysml.RiskKind;
import org.topcased.sysml.Satisfy;
import org.topcased.sysml.ServicePort;
import org.topcased.sysml.SysMLFactory;
import org.topcased.sysml.SysMLPackage;
import org.topcased.sysml.TestCase;
import org.topcased.sysml.Trace;
import org.topcased.sysml.Unit;
import org.topcased.sysml.ValueType;
import org.topcased.sysml.VerdictKind;
import org.topcased.sysml.Verify;
import org.topcased.sysml.VerifyMethodKind;

/**
 * <!-- begin-user-doc --> An implementation of the model  < ? >Package</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class SysMLPackageImpl extends EPackageImpl implements SysMLPackage
{
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass blockEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass flowPortEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass servicePortEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass flowSpecificationEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass blockDefinitionEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass packageSYSMLEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass requirementEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass testCaseEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass requirementDefinitionEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass satisfyEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass deriveReqtEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass verifyEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass fieldEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass rationaleEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass problemEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass valueTypeEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass dimensionEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass unitEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass blockPropertyEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass distributedPropertyEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass itemFlowEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass flowPropertyEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass constraintBlockEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass traceEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass copyEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass refineEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass constraintPropertyEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass containmentEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass requirementRelatedEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EClass modelSYSMLEClass = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EEnum requirementKindEEnum = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EEnum riskKindEEnum = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EEnum verifyMethodKindEEnum = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EEnum verdictKindEEnum = null;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private EEnum flowDirectionKindEEnum = null;

    /**
     * Creates an instance of the model  < ? >Package</b>, registered with
     * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the
     * package package URI value.
     *  < ? >
     * Note: the correct way to create the package is via the static factory
     * method {@link #init init()}, which also performs initialization of the
     * package, or returns the registered package, if one already exists. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.emf.ecore.EPackage.Registry
     * @see org.topcased.sysml.SysMLPackage#eNS_URI
     * @see #init()
     * @generated
     */
    private SysMLPackageImpl()
    {
		super(eNS_URI, SysMLFactory.eINSTANCE);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private static boolean isInited = false;

    /**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
    public static SysMLPackage init()
    {
		if (isInited) return (SysMLPackage)EPackage.Registry.INSTANCE.getEPackage(SysMLPackage.eNS_URI);

		// Obtain or create and register package
		SysMLPackageImpl theSysMLPackage = (SysMLPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof SysMLPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new SysMLPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		EcorePackage.eINSTANCE.eClass();
		UMLPackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theSysMLPackage.createPackageContents();

		// Initialize created meta-data
		theSysMLPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theSysMLPackage.freeze();

		return theSysMLPackage;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getBlock()
    {
		return blockEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getBlock_IsEncapsulated()
    {
		return (EAttribute)blockEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getBlock_OwnedContainment()
    {
		return (EReference)blockEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getFlowPort()
    {
		return flowPortEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getFlowPort_Direction()
    {
		return (EAttribute)flowPortEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getFlowPort_IsConjugated()
    {
		return (EAttribute)flowPortEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getFlowPort_IsAtomic()
    {
		return (EAttribute)flowPortEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getServicePort()
    {
		return servicePortEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getFlowSpecification()
    {
		return flowSpecificationEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getFlowSpecification_OwnedFlowProperty()
    {
		return (EReference)flowSpecificationEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getBlockDefinition()
    {
		return blockDefinitionEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getPackageSYSML()
    {
		return packageSYSMLEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getPackageSYSML_OwnedBlockDefinition()
    {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getPackageSYSML_OwnedRequirementDefinition()
    {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPackageSYSML_OwnedSatisfy() {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(2);
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPackageSYSML_OwnedTestCase() {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(3);
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPackageSYSML_OwnedTraceDependency() {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(4);
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPackageSYSML_OwnedRequirement() {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(5);
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPackageSYSML_OwnedItemFlow() {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(6);
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPackageSYSML_OwnedInterfaces() {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(7);
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPackageSYSML_OwnedGenSet() {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(8);
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPackageSYSML_OwnedActors() {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(9);
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPackageSYSML_OwnedBlocks() {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(10);
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPackageSYSML_OwnedDataTypes() {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(11);
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPackageSYSML_OwnedRelationships() {
		return (EReference)packageSYSMLEClass.getEStructuralFeatures().get(12);
	}

				/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getRequirement()
    {
		return requirementEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getRequirement_Id()
    {
		return (EAttribute)requirementEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getRequirement_Source()
    {
		return (EAttribute)requirementEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getRequirement_Text()
    {
		return (EAttribute)requirementEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getRequirement_Kind()
    {
		return (EAttribute)requirementEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getRequirement_Risk()
    {
		return (EAttribute)requirementEClass.getEStructuralFeatures().get(4);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getRequirement_VerifyMethod()
    {
		return (EAttribute)requirementEClass.getEStructuralFeatures().get(5);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirement_ExtendedField()
    {
		return (EReference)requirementEClass.getEStructuralFeatures().get(6);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirement_DerivedFrom()
    {
		return (EReference)requirementEClass.getEStructuralFeatures().get(7);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirement_Derived()
    {
		return (EReference)requirementEClass.getEStructuralFeatures().get(8);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirement_VerifiedBy()
    {
		return (EReference)requirementEClass.getEStructuralFeatures().get(9);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirement_TracedTo()
    {
		return (EReference)requirementEClass.getEStructuralFeatures().get(10);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirement_SatisfiedBy()
    {
		return (EReference)requirementEClass.getEStructuralFeatures().get(11);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirement_RefinedBy()
    {
		return (EReference)requirementEClass.getEStructuralFeatures().get(12);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirement_Master()
    {
		return (EReference)requirementEClass.getEStructuralFeatures().get(13);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirement_OwnedContainment()
    {
		return (EReference)requirementEClass.getEStructuralFeatures().get(14);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getTestCase()
    {
		return testCaseEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getTestCase_Result()
    {
		return (EAttribute)testCaseEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getRequirementDefinition()
    {
		return requirementDefinitionEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getSatisfy()
    {
		return satisfyEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getDeriveReqt()
    {
		return deriveReqtEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getVerify()
    {
		return verifyEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getField()
    {
		return fieldEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getField_Name()
    {
		return (EAttribute)fieldEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getField_Value()
    {
		return (EAttribute)fieldEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getRationale()
    {
		return rationaleEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getProblem()
    {
		return problemEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getValueType()
    {
		return valueTypeEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getValueType_Unit()
    {
		return (EReference)valueTypeEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getValueType_Dimension()
    {
		return (EReference)valueTypeEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getDimension()
    {
		return dimensionEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getUnit()
    {
		return unitEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getBlockProperty()
    {
		return blockPropertyEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getDistributedProperty()
    {
		return distributedPropertyEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getItemFlow()
    {
		return itemFlowEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getItemFlow_ItemProperty()
    {
		return (EReference)itemFlowEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getFlowProperty()
    {
		return flowPropertyEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EAttribute getFlowProperty_Direction()
    {
		return (EAttribute)flowPropertyEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getConstraintBlock()
    {
		return constraintBlockEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getTrace()
    {
		return traceEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getCopy()
    {
		return copyEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getRefine()
    {
		return refineEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getConstraintProperty()
    {
		return constraintPropertyEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getContainment()
    {
		return containmentEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getRequirementRelated()
    {
		return requirementRelatedEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirementRelated_Verifies()
    {
		return (EReference)requirementRelatedEClass.getEStructuralFeatures().get(0);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirementRelated_TracedFrom()
    {
		return (EReference)requirementRelatedEClass.getEStructuralFeatures().get(1);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirementRelated_Satisfies()
    {
		return (EReference)requirementRelatedEClass.getEStructuralFeatures().get(2);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EReference getRequirementRelated_Refines()
    {
		return (EReference)requirementRelatedEClass.getEStructuralFeatures().get(3);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EClass getModelSYSML()
    {
		return modelSYSMLEClass;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EEnum getRequirementKind()
    {
		return requirementKindEEnum;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EEnum getRiskKind()
    {
		return riskKindEEnum;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EEnum getVerifyMethodKind()
    {
		return verifyMethodKindEEnum;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EEnum getVerdictKind()
    {
		return verdictKindEEnum;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EEnum getFlowDirectionKind()
    {
		return flowDirectionKindEEnum;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public SysMLFactory getSysMLFactory()
    {
		return (SysMLFactory)getEFactoryInstance();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private boolean isCreated = false;

    /**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void createPackageContents()
    {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		blockEClass = createEClass(BLOCK);
		createEAttribute(blockEClass, BLOCK__IS_ENCAPSULATED);
		createEReference(blockEClass, BLOCK__OWNED_CONTAINMENT);

		flowPortEClass = createEClass(FLOW_PORT);
		createEAttribute(flowPortEClass, FLOW_PORT__DIRECTION);
		createEAttribute(flowPortEClass, FLOW_PORT__IS_CONJUGATED);
		createEAttribute(flowPortEClass, FLOW_PORT__IS_ATOMIC);

		servicePortEClass = createEClass(SERVICE_PORT);

		flowSpecificationEClass = createEClass(FLOW_SPECIFICATION);
		createEReference(flowSpecificationEClass, FLOW_SPECIFICATION__OWNED_FLOW_PROPERTY);

		blockDefinitionEClass = createEClass(BLOCK_DEFINITION);

		packageSYSMLEClass = createEClass(PACKAGE_SYSML);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_BLOCK_DEFINITION);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_REQUIREMENT_DEFINITION);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_SATISFY);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_TEST_CASE);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_TRACE_DEPENDENCY);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_REQUIREMENT);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_ITEM_FLOW);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_INTERFACES);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_GEN_SET);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_ACTORS);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_BLOCKS);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_DATA_TYPES);
		createEReference(packageSYSMLEClass, PACKAGE_SYSML__OWNED_RELATIONSHIPS);

		requirementEClass = createEClass(REQUIREMENT);
		createEAttribute(requirementEClass, REQUIREMENT__ID);
		createEAttribute(requirementEClass, REQUIREMENT__SOURCE);
		createEAttribute(requirementEClass, REQUIREMENT__TEXT);
		createEAttribute(requirementEClass, REQUIREMENT__KIND);
		createEAttribute(requirementEClass, REQUIREMENT__RISK);
		createEAttribute(requirementEClass, REQUIREMENT__VERIFY_METHOD);
		createEReference(requirementEClass, REQUIREMENT__EXTENDED_FIELD);
		createEReference(requirementEClass, REQUIREMENT__DERIVED_FROM);
		createEReference(requirementEClass, REQUIREMENT__DERIVED);
		createEReference(requirementEClass, REQUIREMENT__VERIFIED_BY);
		createEReference(requirementEClass, REQUIREMENT__TRACED_TO);
		createEReference(requirementEClass, REQUIREMENT__SATISFIED_BY);
		createEReference(requirementEClass, REQUIREMENT__REFINED_BY);
		createEReference(requirementEClass, REQUIREMENT__MASTER);
		createEReference(requirementEClass, REQUIREMENT__OWNED_CONTAINMENT);

		testCaseEClass = createEClass(TEST_CASE);
		createEAttribute(testCaseEClass, TEST_CASE__RESULT);

		requirementDefinitionEClass = createEClass(REQUIREMENT_DEFINITION);

		satisfyEClass = createEClass(SATISFY);

		deriveReqtEClass = createEClass(DERIVE_REQT);

		verifyEClass = createEClass(VERIFY);

		fieldEClass = createEClass(FIELD);
		createEAttribute(fieldEClass, FIELD__NAME);
		createEAttribute(fieldEClass, FIELD__VALUE);

		rationaleEClass = createEClass(RATIONALE);

		problemEClass = createEClass(PROBLEM);

		valueTypeEClass = createEClass(VALUE_TYPE);
		createEReference(valueTypeEClass, VALUE_TYPE__UNIT);
		createEReference(valueTypeEClass, VALUE_TYPE__DIMENSION);

		dimensionEClass = createEClass(DIMENSION);

		unitEClass = createEClass(UNIT);

		blockPropertyEClass = createEClass(BLOCK_PROPERTY);

		distributedPropertyEClass = createEClass(DISTRIBUTED_PROPERTY);

		itemFlowEClass = createEClass(ITEM_FLOW);
		createEReference(itemFlowEClass, ITEM_FLOW__ITEM_PROPERTY);

		flowPropertyEClass = createEClass(FLOW_PROPERTY);
		createEAttribute(flowPropertyEClass, FLOW_PROPERTY__DIRECTION);

		constraintBlockEClass = createEClass(CONSTRAINT_BLOCK);

		traceEClass = createEClass(TRACE);

		copyEClass = createEClass(COPY);

		refineEClass = createEClass(REFINE);

		constraintPropertyEClass = createEClass(CONSTRAINT_PROPERTY);

		containmentEClass = createEClass(CONTAINMENT);

		requirementRelatedEClass = createEClass(REQUIREMENT_RELATED);
		createEReference(requirementRelatedEClass, REQUIREMENT_RELATED__VERIFIES);
		createEReference(requirementRelatedEClass, REQUIREMENT_RELATED__TRACED_FROM);
		createEReference(requirementRelatedEClass, REQUIREMENT_RELATED__SATISFIES);
		createEReference(requirementRelatedEClass, REQUIREMENT_RELATED__REFINES);

		modelSYSMLEClass = createEClass(MODEL_SYSML);

		// Create enums
		requirementKindEEnum = createEEnum(REQUIREMENT_KIND);
		riskKindEEnum = createEEnum(RISK_KIND);
		verifyMethodKindEEnum = createEEnum(VERIFY_METHOD_KIND);
		verdictKindEEnum = createEEnum(VERDICT_KIND);
		flowDirectionKindEEnum = createEEnum(FLOW_DIRECTION_KIND);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private boolean isInitialized = false;

    /**
     * Complete the initialization of the package and its meta-model. This
     * method is guarded to have no affect on any invocation but its first. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void initializePackageContents()
    {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		UMLPackage theUMLPackage = (UMLPackage)EPackage.Registry.INSTANCE.getEPackage(UMLPackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		blockEClass.getESuperTypes().add(theUMLPackage.getClass_());
		flowPortEClass.getESuperTypes().add(theUMLPackage.getPort());
		servicePortEClass.getESuperTypes().add(theUMLPackage.getPort());
		flowSpecificationEClass.getESuperTypes().add(theUMLPackage.getInterface());
		blockDefinitionEClass.getESuperTypes().add(this.getPackageSYSML());
		packageSYSMLEClass.getESuperTypes().add(theUMLPackage.getPackage());
		requirementEClass.getESuperTypes().add(theUMLPackage.getClass_());
		testCaseEClass.getESuperTypes().add(theUMLPackage.getBehavior());
		requirementDefinitionEClass.getESuperTypes().add(this.getPackageSYSML());
		satisfyEClass.getESuperTypes().add(theUMLPackage.getRealization());
		deriveReqtEClass.getESuperTypes().add(this.getTrace());
		verifyEClass.getESuperTypes().add(this.getTrace());
		fieldEClass.getESuperTypes().add(theUMLPackage.getElement());
		rationaleEClass.getESuperTypes().add(theUMLPackage.getComment());
		problemEClass.getESuperTypes().add(theUMLPackage.getComment());
		valueTypeEClass.getESuperTypes().add(theUMLPackage.getDataType());
		dimensionEClass.getESuperTypes().add(this.getValueType());
		unitEClass.getESuperTypes().add(this.getValueType());
		blockPropertyEClass.getESuperTypes().add(theUMLPackage.getProperty());
		distributedPropertyEClass.getESuperTypes().add(this.getBlockProperty());
		itemFlowEClass.getESuperTypes().add(theUMLPackage.getInformationFlow());
		flowPropertyEClass.getESuperTypes().add(theUMLPackage.getProperty());
		constraintBlockEClass.getESuperTypes().add(this.getBlock());
		traceEClass.getESuperTypes().add(theUMLPackage.getDependency());
		copyEClass.getESuperTypes().add(this.getTrace());
		refineEClass.getESuperTypes().add(this.getTrace());
		constraintPropertyEClass.getESuperTypes().add(this.getBlockProperty());
		containmentEClass.getESuperTypes().add(theUMLPackage.getDependency());
		requirementRelatedEClass.getESuperTypes().add(theUMLPackage.getNamedElement());
		modelSYSMLEClass.getESuperTypes().add(this.getPackageSYSML());

		// Initialize classes and features; add operations and parameters
		initEClass(blockEClass, Block.class, "Block", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getBlock_IsEncapsulated(), theUMLPackage.getBoolean(), "isEncapsulated", "false", 0, 1, Block.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBlock_OwnedContainment(), this.getContainment(), null, "ownedContainment", null, 0, -1, Block.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(flowPortEClass, FlowPort.class, "FlowPort", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getFlowPort_Direction(), this.getFlowDirectionKind(), "direction", null, 0, 1, FlowPort.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFlowPort_IsConjugated(), theUMLPackage.getBoolean(), "isConjugated", null, 0, 1, FlowPort.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFlowPort_IsAtomic(), theUMLPackage.getBoolean(), "isAtomic", "true", 0, 1, FlowPort.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		addEOperation(flowPortEClass, theUMLPackage.getBoolean(), "validateConnectedPortsCompatibility", 0, 1);

		addEOperation(flowPortEClass, theUMLPackage.getBoolean(), "validateType", 0, 1);

		initEClass(servicePortEClass, ServicePort.class, "ServicePort", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		addEOperation(servicePortEClass, theUMLPackage.getBoolean(), "validateConnectedPortsCompatibility", 0, 1);

		initEClass(flowSpecificationEClass, FlowSpecification.class, "FlowSpecification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getFlowSpecification_OwnedFlowProperty(), this.getFlowProperty(), null, "ownedFlowProperty", null, 0, -1, FlowSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(blockDefinitionEClass, BlockDefinition.class, "BlockDefinition", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(packageSYSMLEClass, PackageSYSML.class, "PackageSYSML", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPackageSYSML_OwnedBlockDefinition(), this.getBlockDefinition(), null, "ownedBlockDefinition", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedRequirementDefinition(), this.getRequirementDefinition(), null, "ownedRequirementDefinition", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedSatisfy(), this.getSatisfy(), null, "ownedSatisfy", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedTestCase(), this.getTestCase(), null, "ownedTestCase", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedTraceDependency(), this.getTrace(), null, "ownedTraceDependency", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedRequirement(), this.getRequirement(), null, "ownedRequirement", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedItemFlow(), this.getItemFlow(), null, "ownedItemFlow", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedInterfaces(), theUMLPackage.getInterface(), null, "ownedInterfaces", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedGenSet(), theUMLPackage.getGeneralizationSet(), null, "ownedGenSet", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedActors(), theUMLPackage.getActor(), null, "ownedActors", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedBlocks(), this.getBlock(), null, "ownedBlocks", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedDataTypes(), theUMLPackage.getDataType(), null, "ownedDataTypes", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPackageSYSML_OwnedRelationships(), theUMLPackage.getRelationship(), null, "ownedRelationships", null, 0, -1, PackageSYSML.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(requirementEClass, Requirement.class, "Requirement", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRequirement_Id(), theUMLPackage.getString(), "id", null, 0, 1, Requirement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRequirement_Source(), theUMLPackage.getString(), "source", null, 0, 1, Requirement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRequirement_Text(), theUMLPackage.getString(), "text", null, 0, 1, Requirement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRequirement_Kind(), this.getRequirementKind(), "kind", null, 0, 1, Requirement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRequirement_Risk(), this.getRiskKind(), "risk", null, 0, 1, Requirement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRequirement_VerifyMethod(), this.getVerifyMethodKind(), "verifyMethod", null, 0, 1, Requirement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRequirement_ExtendedField(), this.getField(), null, "extendedField", null, 0, -1, Requirement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRequirement_DerivedFrom(), this.getRequirement(), null, "derivedFrom", null, 0, -1, Requirement.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getRequirement_Derived(), this.getRequirement(), null, "derived", "", 0, -1, Requirement.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getRequirement_VerifiedBy(), this.getTestCase(), null, "verifiedBy", "", 0, -1, Requirement.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getRequirement_TracedTo(), theUMLPackage.getNamedElement(), null, "tracedTo", null, 0, -1, Requirement.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getRequirement_SatisfiedBy(), theUMLPackage.getNamedElement(), null, "satisfiedBy", null, 0, -1, Requirement.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getRequirement_RefinedBy(), theUMLPackage.getNamedElement(), null, "refinedBy", null, 0, -1, Requirement.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getRequirement_Master(), this.getRequirement(), null, "master", null, 0, 1, Requirement.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getRequirement_OwnedContainment(), this.getContainment(), null, "ownedContainment", null, 0, -1, Requirement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(testCaseEClass, TestCase.class, "TestCase", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTestCase_Result(), this.getVerdictKind(), "result", null, 0, 1, TestCase.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(requirementDefinitionEClass, RequirementDefinition.class, "RequirementDefinition", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(satisfyEClass, Satisfy.class, "Satisfy", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(deriveReqtEClass, DeriveReqt.class, "DeriveReqt", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(verifyEClass, Verify.class, "Verify", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(fieldEClass, Field.class, "Field", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getField_Name(), theUMLPackage.getString(), "name", null, 0, 1, Field.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getField_Value(), theUMLPackage.getString(), "value", null, 0, 1, Field.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rationaleEClass, Rationale.class, "Rationale", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(problemEClass, Problem.class, "Problem", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(valueTypeEClass, ValueType.class, "ValueType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getValueType_Unit(), this.getUnit(), null, "unit", null, 0, 1, ValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getValueType_Dimension(), this.getDimension(), null, "dimension", null, 0, 1, ValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dimensionEClass, Dimension.class, "Dimension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(unitEClass, Unit.class, "Unit", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(blockPropertyEClass, BlockProperty.class, "BlockProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(distributedPropertyEClass, DistributedProperty.class, "DistributedProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(itemFlowEClass, ItemFlow.class, "ItemFlow", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getItemFlow_ItemProperty(), this.getBlockProperty(), null, "itemProperty", null, 0, 1, ItemFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(flowPropertyEClass, FlowProperty.class, "FlowProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getFlowProperty_Direction(), this.getFlowDirectionKind(), "direction", null, 1, 1, FlowProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		addEOperation(flowPropertyEClass, theUMLPackage.getBoolean(), "validateType", 0, 1);

		initEClass(constraintBlockEClass, ConstraintBlock.class, "ConstraintBlock", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(traceEClass, Trace.class, "Trace", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(copyEClass, Copy.class, "Copy", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(refineEClass, Refine.class, "Refine", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(constraintPropertyEClass, ConstraintProperty.class, "ConstraintProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(containmentEClass, Containment.class, "Containment", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(requirementRelatedEClass, RequirementRelated.class, "RequirementRelated", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRequirementRelated_Verifies(), this.getRequirement(), null, "verifies", null, 0, -1, RequirementRelated.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRequirementRelated_TracedFrom(), this.getRequirement(), null, "tracedFrom", null, 0, -1, RequirementRelated.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRequirementRelated_Satisfies(), this.getRequirement(), null, "satisfies", null, 0, -1, RequirementRelated.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRequirementRelated_Refines(), this.getRequirement(), null, "refines", null, 0, -1, RequirementRelated.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(modelSYSMLEClass, ModelSYSML.class, "ModelSYSML", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		// Initialize enums and add enum literals
		initEEnum(requirementKindEEnum, RequirementKind.class, "RequirementKind");
		addEEnumLiteral(requirementKindEEnum, RequirementKind.FUNCTIONAL_LITERAL);
		addEEnumLiteral(requirementKindEEnum, RequirementKind.PERFORMANCE_LITERAL);
		addEEnumLiteral(requirementKindEEnum, RequirementKind.INTERFACE_LITERAL);

		initEEnum(riskKindEEnum, RiskKind.class, "RiskKind");
		addEEnumLiteral(riskKindEEnum, RiskKind.HIGH_LITERAL);
		addEEnumLiteral(riskKindEEnum, RiskKind.MEDIUM_LITERAL);
		addEEnumLiteral(riskKindEEnum, RiskKind.LOW_LITERAL);

		initEEnum(verifyMethodKindEEnum, VerifyMethodKind.class, "VerifyMethodKind");
		addEEnumLiteral(verifyMethodKindEEnum, VerifyMethodKind.ANALYSIS_LITERAL);
		addEEnumLiteral(verifyMethodKindEEnum, VerifyMethodKind.DEMONSTRATION_LITERAL);
		addEEnumLiteral(verifyMethodKindEEnum, VerifyMethodKind.INSPECTION_LITERAL);
		addEEnumLiteral(verifyMethodKindEEnum, VerifyMethodKind.TEST_LITERAL);

		initEEnum(verdictKindEEnum, VerdictKind.class, "VerdictKind");
		addEEnumLiteral(verdictKindEEnum, VerdictKind.PASS_LITERAL);
		addEEnumLiteral(verdictKindEEnum, VerdictKind.FAIL_LITERAL);
		addEEnumLiteral(verdictKindEEnum, VerdictKind.INCONCLUSIVE_LITERAL);
		addEEnumLiteral(verdictKindEEnum, VerdictKind.ERROR_LITERAL);

		initEEnum(flowDirectionKindEEnum, FlowDirectionKind.class, "FlowDirectionKind");
		addEEnumLiteral(flowDirectionKindEEnum, FlowDirectionKind.INOUT_LITERAL);
		addEEnumLiteral(flowDirectionKindEEnum, FlowDirectionKind.IN_LITERAL);
		addEEnumLiteral(flowDirectionKindEEnum, FlowDirectionKind.OUT_LITERAL);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http://www.topcased.org/uuid
		createUuidAnnotations();
		// subsets
		createSubsetsAnnotations();
	}

    /**
     * Initializes the annotations for  < ? >http://www.topcased.org/uuid</b>.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void createUuidAnnotations()
    {

    }

    /**
     * Initializes the annotations for  < ? >subsets</b>. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void createSubsetsAnnotations()
    {

    }

} // SysMLPackageImpl
