package org.topcased.traceability.hmi.actions;

import org.topcased.traceability.hmi.TtmPlugin;
import org.topcased.traceability.hmi.contextmenu.ContextAction;

import tte.impl.Engine;
import ttm.Element;


public class EditDocumentAction extends ContextAction {

	public EditDocumentAction() {
		super("Open document", null);
	}

	@Override
	protected void selectionHasChanged() {
		if (getSelection() instanceof Element) {
			setEnabled(true);
		}
		else {
			setEnabled(false);
		}
	}
	
	@Override
	public void run() {
		Engine engine = new Engine();
		try {
			engine.editElement((Element)getSelection());
		} catch (Exception e) {
			TtmPlugin.log(e);
		}
	}

}
