//------------------------------------------------
// $Id: AnalyserArgumentsSection.java,v 1.1 2007-05-22 10:23:47 matg Exp $
// (c) Anyware Technologies 2007    www.anyware-tech.com
//------------------------------------------------
package org.topcased.traceability.hmi.properties.document;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.swt.SWT;
import org.topcased.tabbedproperties.sections.AbstractStringPropertySection;

import ttm.TtmPackage;

/**
 * Section use to display the Analyser Arguments property of a Document
 * <br>
 * creation : 5 avr. 07
 *
 * @author <a href="mailto:mickael.gerard@anyware-tech.com">Mickael Gerard</a>
 */
public class AnalyserArgumentsSection extends AbstractStringPropertySection
{

    @Override
    protected EStructuralFeature getFeature()
    {
        return TtmPackage.eINSTANCE.getDocument_AnalyzerArguments();
    }

    @Override
    protected String getLabelText()
    {
       return "Analyser Arguments";
    }
    
    @Override
    protected int getStyle()
    {     
        return SWT.MULTI;
    }
    
    @Override
    public boolean shouldUseExtraSpace()
    {
       return true;
    }
    
}
