/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors: Mathieu Garcia (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.traceability.hmi.util;

/**
 * Created on 21 f�vr. 07
 * 
 * @author <a href="mailto:mathieu.garcia@anyware-tech.com">Mathieu Garcia</a>
 * 
 * An interface that provides some constants
 * 
 */
public interface TraceabilityConstants
{

    /**
     * SECTION_IMAGE_KEY
     */
    public static final String SECTION_IMAGE_KEY = "SECTION";

    /**
     * REQUIREMENT_IMAGE_KEY
     */
    public static final String REQUIREMENT_IMAGE_KEY = "REQUIREMENT";

    /**
     * COVER_POINT_IMAGE_KEY
     */
    public static final String COVER_POINT_IMAGE_KEY = "COVER_POINT";
    
    /**
     * SEARCH_IMAGE_KEY
     */
    public static final String SEARCH_IMAGE_KEY = "SEARCH";
    
    /**
     * RULE_OK_KEY
     */
    public static final String RULE_OK_KEY = "RULE_OK";

    /**
     * RULE_KO_KEY
     */
    public static final String RULE_KO_KEY = "RULE_KO";

    /**
     * NO_PROJECT_LOADED
     */
    public static final String NO_PROJECT_LOADED = "No project loaded.";

    /**
     * LOADING_PROJECT
     */
    public static final String LOADING_PROJECT = "Loading project...";
    
    /**
     * NOT_ANALYSED_PROJECT
     */
    public static final String NOT_ANALYSED_PROJECT = "Not analysed project ...";

}
