/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.web.server;

/**
 * Defines a customized External Service Exception.
 * 
 * @author <a href="mailto:david.brouard@c-s.fr">David BROUARD</a>
 */
public class ExternalServiceException extends Exception
{
	private static final long serialVersionUID = 1L;

	/**
	 * Constructor 
	 * 
	 * @param message The message of the exception
	 */
	public ExternalServiceException(String message)
	{
		super(message);
	}
}
