/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.web.server.SOAP;

import java.nio.channels.SelectionKey;
import javax.xml.soap.SOAPMessage;

/**
 * @author <a href="mailto:david.brouard@c-s.fr">David BROUARD</a>
 */
public interface SOAPCallback
{
	public void onMessage(SOAPMessage requestMsg_, SelectionKey channel);

}
