package tte.exceptions;

/**
 * Exception raised when Report generation cannot be complete.
 *
 */
public class ReportGenerationException extends Exception {

    /**
     * exception serialVersionUID.
     */
    private static final long serialVersionUID = 902923415644583957L;

    /**
     * Creates an instance of report generation exception
     *  with a message in parameter.
     * @param message is the error message that isthrown
     */
    public ReportGenerationException(final String message) {
        super(message);
    }

}
