package tte.rules.basics;

import tte.rules.IRule;
import ttm.Element;
import ttm.Project;
import ttm.Requirement;

public class DerivedRequirement implements IRule
{

    public Boolean isRaisedForElement(Element elt, Project project)
    {
        Requirement req = (Requirement)elt;
        return (req.getCoverLinks().isEmpty()) 
                    && (!(req.getDocument().getCoveredDocuments().isEmpty()) 
                         || project.isAnyDocumentCovered());     
    }

    public String getDisplayMessageForElement(Element elt)
    {
        return "Derived Requirement: "+((Requirement)elt).getIdent();
    }

}
